package net.smart.core;

import java.util.*;

import net.minecraft.client.multiplayer.*;
import net.minecraft.entity.player.*;
import net.minecraft.network.*;
import net.minecraft.server.management.*;
import net.minecraft.network.play.client.*;

public class SmartCoreEventHandler
{
	private final static Set<SmartCoreEventHandler> handlers = new HashSet<SmartCoreEventHandler>();

	public static void Add(SmartCoreEventHandler handler)
	{
		handlers.add(handler);
	}

	public static void Remove(SmartCoreEventHandler handler)
	{
		handlers.remove(handler);
	}

	public static void NetHandlerPlayServer_beforeProcessPlayer(NetHandlerPlayServer netServerHandler)
	{
		for(SmartCoreEventHandler eventHandler : handlers)
			eventHandler.beforeProcessPlayer(netServerHandler);
	}

	public static void NetHandlerPlayServer_afterProcessPlayer(NetHandlerPlayServer netServerHandler)
	{
		for(SmartCoreEventHandler eventHandler : handlers)
			eventHandler.afterProcessPlayer(netServerHandler);
	}

	public static void NetHandlerPlayServer_beforeProcessPlayerBlockPlacement(NetHandlerPlayServer netServerHandler, C08PacketPlayerBlockPlacement packet15place)
	{
		for(SmartCoreEventHandler eventHandler : handlers)
			eventHandler.beforeProcessPlayerBlockPlacement(netServerHandler, packet15place);
	}

	public static void NetHandlerPlayServer_afterProcessPlayerBlockPlacement(NetHandlerPlayServer netServerHandler, C08PacketPlayerBlockPlacement packet15place)
	{
		for(SmartCoreEventHandler eventHandler : handlers)
			eventHandler.afterProcessPlayerBlockPlacement(netServerHandler, packet15place);
	}

	public static void PlayerControllerMP_beforeOnPlayerRightClick(PlayerControllerMP playerControllerMP, EntityPlayer entityPlayerSP)
	{
		for(SmartCoreEventHandler eventHandler : handlers)
			eventHandler.beforeOnPlayerRightClick(playerControllerMP, entityPlayerSP);
	}

	public static void PlayerControllerMP_afterOnPlayerRightClick(PlayerControllerMP playerControllerMP, EntityPlayer entityPlayerSP)
	{
		for(SmartCoreEventHandler eventHandler : handlers)
			eventHandler.afterOnPlayerRightClick(playerControllerMP, entityPlayerSP);
	}

	public static void ItemInWorldManager_beforeActivateBlockOrUseItem(ItemInWorldManager itemInWorldManager, EntityPlayer entityPlayer)
	{
		for(SmartCoreEventHandler eventHandler : handlers)
			eventHandler.beforeActivateBlockOrUseItem(itemInWorldManager, entityPlayer);
	}

	public static void ItemInWorldManager_afterActivateBlockOrUseItem(ItemInWorldManager itemInWorldManager, EntityPlayer entityPlayer)
	{
		for(SmartCoreEventHandler eventHandler : handlers)
			eventHandler.afterActivateBlockOrUseItem(itemInWorldManager, entityPlayer);
	}

	@SuppressWarnings("unused")
	public void beforeProcessPlayer(NetHandlerPlayServer netServerHandler)
	{
	}

	@SuppressWarnings("unused")
	public void afterProcessPlayer(NetHandlerPlayServer netServerHandler)
	{
	}

	@SuppressWarnings("unused")
	public void beforeProcessPlayerBlockPlacement(NetHandlerPlayServer netServerHandler, C08PacketPlayerBlockPlacement packet15place)
	{
	}

	@SuppressWarnings("unused")
	public void afterProcessPlayerBlockPlacement(NetHandlerPlayServer netServerHandler, C08PacketPlayerBlockPlacement packet15place)
	{
	}

	@SuppressWarnings("unused")
	public void beforeOnPlayerRightClick(PlayerControllerMP playerControllerMP, EntityPlayer entityPlayerSP)
	{
	}

	@SuppressWarnings("unused")
	public void afterOnPlayerRightClick(PlayerControllerMP playerControllerMP, EntityPlayer entityPlayerSP)
	{
	}

	@SuppressWarnings("unused")
	public void beforeActivateBlockOrUseItem(ItemInWorldManager itemInWorldManager, EntityPlayer entityPlayer)
	{
	}

	@SuppressWarnings("unused")
	public void afterActivateBlockOrUseItem(ItemInWorldManager itemInWorldManager, EntityPlayer entityPlayer)
	{
	}
}