package net.smart.core;

import java.util.*;

import net.minecraft.launchwrapper.*;

public class SmartCoreTransformer implements IClassTransformer
{
	@Override
	public byte[] transform(String name, String transformedName, byte[] bytes)
	{
		List<SmartCoreTransformation> list = null;
		for(SmartCoreTransformation transformation : _transformations)
			if(transformedName.equals(transformation.className))
				(list == null ? (list = new ArrayList<SmartCoreTransformation>()) : list).add(transformation);

		if(list != null)
			return SmartCoreClassVisitor.transform(bytes, list);
		return bytes;
	}

	private static final SmartCoreTransformation[] _transformations = new SmartCoreTransformation[]
	{
		new SmartCoreTransformation
		(
			"net.minecraft.network.NetHandlerPlayServer",
			Name("processPlayer", "a"),
			new String[]
			{
				Name("net.minecraft.network.play.client.C03PacketPlayer", "jd")
			},
			null,
			null,
			"net.smart.core.SmartCoreEventHandler",
			null
		),
		new SmartCoreTransformation
		(
			"net.minecraft.network.NetHandlerPlayServer",
			Name("processPlayerBlockPlacement", "a"),
			new String[]
			{
				Name("net.minecraft.network.play.client.C08PacketPlayerBlockPlacement", "jo")
			},
			new boolean[] { true },
			null,
			"net.smart.core.SmartCoreEventHandler",
			null
		),
		new SmartCoreTransformation
		(
			"cpw.mods.fml.common.discovery.ModDiscoverer",
			"findModDirMods",
			null,
			null,
			null,
			"net.smart.core.SmartCorePlugin",
			null,
			true,
			false,
			false
		),
		new SmartCoreTransformation
		(
			Name("net.minecraft.client.multiplayer.PlayerControllerMP", "bje"),
			Name("onPlayerRightClick", "a"),
			new String[]
			{
				Name("net.minecraft.entity.player.EntityPlayer", "yz"),
				Name("net.minecraft.world.World", "ahb"),
				Name("net.minecraft.item.ItemStack", "add"),
				"I",
				"I",
				"I",
				"I",
				Name("net.minecraft.util.Vec3", "azw")
			},
			new boolean[] { true },
			"Z",
			"net.smart.core.SmartCoreEventHandler",
			null
		),
		new SmartCoreTransformation
		(
			Name("net.minecraft.server.management.ItemInWorldManager", "qx"),
			Name("activateBlockOrUseItem", "a"),
			new String[]
			{
				Name("net.minecraft.entity.player.EntityPlayer", "yz"),
				Name("net.minecraft.world.World", "ahb"),
				Name("net.minecraft.item.ItemStack", "add"),
				"I",
				"I",
				"I",
				"I",
				"F",
				"F",
				"F"
			},
			new boolean[] { true },
			"Z",
			"net.smart.core.SmartCoreEventHandler",
			null
		)
	};

	private static String Name(String deobfuscated, String obfuscated)
	{
		return SmartCorePlugin.isObfuscated ? obfuscated : deobfuscated;
	}
}